#line 1 "C:/Users/Singh/Desktop/Tardis/tardis.c"
#pragma config MCLR=ON
#line 6 "C:/Users/Singh/Desktop/Tardis/tardis.c"
 sbit Soft_I2C_Scl at RB3_bit;
sbit Soft_I2C_Sda at RB4_bit;
sbit Soft_I2C_Scl_Direction at TRISB3_bit;
sbit Soft_I2C_Sda_Direction at TRISB4_bit;

sbit Set_b at RC4_bit;
sbit Inr_b at RC5_bit;
sbit Dec_b at RC0_bit;
sbit Log_b at RC1_bit;

sbit LCD_RS at RE0_bit;
sbit LCD_EN at RE2_bit;
sbit LCD_D4 at RD4_bit;
sbit LCD_D5 at RD5_bit;
sbit LCD_D6 at RD6_bit;
sbit LCD_D7 at RD7_bit;

sbit LCD_RS_Direction at TRISE0_bit;
sbit LCD_EN_Direction at TRISE2_bit;
sbit LCD_D4_Direction at TRISD4_bit;
sbit LCD_D5_Direction at TRISD5_bit;
sbit LCD_D6_Direction at TRISD6_bit;
sbit LCD_D7_Direction at TRISD7_bit;

char colon[] = ":";

char i;
unsigned char sec, min1, hr, week_day, day, mn, year;
char *txt, tnum[4];
unsigned short myDate,myHour,myMin,myYear,myMon,myDay;


void Write_Time() {
 Soft_I2C_Start();
 Soft_I2C_Write( 0xD0 );
 Soft_I2C_Write(0);
 Soft_I2C_Write(0x80);
 Soft_I2C_Write(myMin);
 Soft_I2C_Write(myHour);
 Soft_I2C_Write(myDay);
 Soft_I2C_Write(myDate);
 Soft_I2C_Write(myMon);
 Soft_I2C_Write(myYear);
 Soft_I2C_Stop();

 Soft_I2C_Start();
 Soft_I2C_Write( 0xD0 );
 Soft_I2C_Write(0);
 Soft_I2C_Write(0);
 Soft_I2C_Stop();
}

void Read_Time(char *sec, char *min, char *hr, char *week_day, char *day, char *mn, char *year) {
 Soft_I2C_Start();
 Soft_I2C_Write( 0xD0 );
 Soft_I2C_Write(0);
 Soft_I2C_Start();
 Soft_I2C_Write(0xD1);
 *sec =Soft_I2C_Read(1);
 *min =Soft_I2C_Read(1);
 *hr =Soft_I2C_Read(1);
 *week_day =Soft_I2C_Read(1);
 *day =Soft_I2C_Read(1);
 *mn =Soft_I2C_Read(1);
 *year =Soft_I2C_Read(0);
 Soft_I2C_Stop();
}

void Transform_Time(char *sec, char *min, char *hr, char *week_day, char *day, char *mn, char *year) {
 *sec = ((*sec & 0x70) >> 4)*10 + (*sec & 0x0F);
 *min = ((*min & 0xF0) >> 4)*10 + (*min & 0x0F);
 *hr = ((*hr & 0x30) >> 4)*10 + (*hr & 0x0F);
 *week_day =(*week_day & 0x07);
 *day = ((*day & 0xF0) >> 4)*10 + (*day & 0x0F);
 *mn = ((*mn & 0x10) >> 4)*10 + (*mn & 0x0F);
 *year = ((*year & 0xF0)>>4)*10+(*year & 0x0F);
}

void Display_Time(char sec, char min, char hr, char week_day, char day, char mn, char year) {
 switch(week_day){
 case 1: txt="Sun"; break;
 case 2: txt="Mon"; break;
 case 3: txt="Tue"; break;
 case 4: txt="Wed"; break;
 case 5: txt="Thu"; break;
 case 6: txt="Fri"; break;
 case 7: txt="Sat"; break;
 }

 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);



 Lcd_Chr(1, 1, (hr / 10) + 48);
 Lcd_Chr(1, 2, (hr % 10) + 48);
 Lcd_Chr(1,3,':') ;
 Lcd_Chr(1, 4, (min / 10) + 48);
 Lcd_Chr(1,5, (min % 10) + 48);
 Lcd_Chr(1,6,':') ;
 Lcd_Chr(1,7, (sec / 10) + 48);
 Lcd_Chr(1,8, (sec % 10) + 48);

 Lcd_Chr(1, 10, (day / 10) + 48);
 Lcd_Chr(1, 11, (day % 10) + 48);
 Lcd_Chr(1,12,'/') ;

 Lcd_Chr(1,13, (mn % 10) + 48);
 Lcd_Chr(1,14,'/') ;
 Lcd_Chr(1,15, (year / 10) + 48);
 Lcd_Chr(1,16, (year % 10) + 48);
}

void Set_Time()
{
 myDate=0x20;
 myMon=0x03;
 myYear=0x14;
 myHour=0x12;
 myMin=0x55;
 myDay= 0x05;
 Write_Time();
}


void Init_Main_Simple() {
 ADCON1 = 0x0F;
 CMCON = 0x07;
 INTCON2 = 0x80;



 LATA = 0x00;
 LATC = 0x00;

 LATE = 0x00;


 TRISA = 0x00;
 TRISB = 0x00;
 TRISC = 0x00;
 TRISD = 0x00;
 TRISE = 0x00;
 PORTC=0x33;
 TRISC=0x33;

 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);

 Soft_I2C_Init();
 Lcd_Out(1,1,"Software I2C");Lcd_Out(2,1," Initialized") ; Delay_ms(500);
}



void main() {
 Init_Main_Simple();


 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(1,1,"Digital Clock"); Lcd_Out(2,1," using DS1307");

Soft_I2C_Sda_Direction = 1;
 while (1) {
 Read_Time(&sec,&min1,&hr,&week_day,&day,&mn,&year);
 Transform_Time(&sec,&min1,&hr,&week_day,&day,&mn,&year);

 Display_Time(sec, min1, hr, week_day, day, mn, year);
 }
}
